#include "Arduino.h"
#include "MuxShield.h"
#include "MyButton.h"

MyButton::MyButton(int buttonPin, MuxShield *muxShield, int muxShieldRow, int buttonNormal) {
  _debounceTimeout = 150;
  _buttonPin = buttonPin;
  _lastButtonState = buttonNormal;
  _buttonNormal = buttonNormal;
  if (muxShield) {
    _muxShield = muxShield;
    _muxShieldRow = muxShieldRow;
    _useMuxShield = true;
  } else {
    _useMuxShield = false;
  }
}

void MyButton::setDebounceTimeout(int debounceTimeout) {
  _debounceTimeout = debounceTimeout;
}

int MyButton::getButtonState() {
  if (_useMuxShield) {
    return _muxShield->digitalReadMS(_muxShieldRow, _buttonPin);
  }
  return digitalRead(_buttonPin);
}

int MyButton::getDebounceButtonState() {
  int buttonState = getButtonState();
  if (buttonState == _buttonNormal) {
    _lastButtonState = _buttonNormal;
    return _buttonNormal;
  }
  if (buttonState != _lastButtonState) {
    _lastButtonState = buttonState;
    _debounceTime = millis();
    return _buttonNormal;
  }
  if ((millis() - _debounceTime) > _debounceTimeout) {
    _lastButtonState = _buttonNormal;
    return buttonState;
  }
  return _buttonNormal;
}
