/*
  MyButton.h - A library for defining a Button
  Created by Ken Rumer, May 13, 2014.
  Released into the public domain.
*/
#ifndef MyButton_h
#define MyButton_h

#include "Arduino.h"
#include "MuxShield.h"

class MyButton
{
  public:
    MyButton(int buttonPin, MuxShield *muxShield=NULL, int muxShieldRow=2, int buttonNormal=HIGH);
    int getButtonState();
    int getDebounceButtonState();
    void setDebounceTimeout(int debounceTimeout);
  private:
    int _buttonPin;
    int _lastButtonState;
    int _buttonNormal;
    long _debounceTime;
    int _debounceTimeout;
    int _useMuxShield;
    int _muxShieldRow;
    MuxShield *_muxShield;
};
#endif
