#include "Arduino.h"
#include "MuxShield.h"
#include "MyRelay.h"

MyRelay::MyRelay(int relayPin, MuxShield *muxShield, int muxShieldRow) {
  _useMuxShield = false;
  _muxShieldRow = 0;
  _relayPin = relayPin;
  if (muxShield) {
    _muxShield = muxShield;
    _muxShieldRow = muxShieldRow;
    _useMuxShield = true;
  }
}

void MyRelay::setRelay(int mode) {
  if (_useMuxShield) {
    _muxShield->digitalWriteMS(_muxShieldRow, _relayPin, mode);
  } else {
    digitalWrite(_relayPin, mode);
  }
}
