/*
  MyThermistor.h - A library for getting the value of a Thermistor
   from a Mux Shield II
  Created by Ken Rumer, July 5, 2014.
  Released into the public domain.
*/
#ifndef MyThermistor_h
#define MyThermistor_h

#include "Arduino.h"
#include "MuxShield.h"
#include "math.h"

class MyThermistor
{
  public:
    MyThermistor(int thermistorPin, MuxShield *muxShield=NULL, int muxShieldRow=2);
    int getThermistorValue();
    double getCTemperature();
    double getFTemperature();
  private:
    double _convertRawADC(int thermistorValue);
    int _thermistorPin;
    int _useMuxShield;
    int _muxShieldRow;
    MuxShield *_muxShield;
};
#endif
